=== debian/changelog ===
xxhash (0.6.5-2) unstable; urgency=medium

  [ Matthias Klose ]
  * Add a symbols file. (Closes: #913873)

  [ Norbert Preining ]
  * Bump standards version, no changes necessary

 -- Norbert Preining <preining@debian.org>  Sat, 17 Nov 2018 01:17:27 +0900

xxhash (0.6.5-1) unstable; urgency=low

  * Initial release (Closes: #908175)

 -- Norbert Preining <preining@debian.org>  Fri, 07 Sep 2018 12:10:46 +0900
