=== debian/changelog ===
xxhash (0.7.0-2) unstable; urgency=medium

  * Upload to unstable

 -- Norbert Preining <norbert@preining.info>  Wed, 10 Jul 2019 17:37:07 +0900

xxhash (0.7.0-1) experimental; urgency=medium

  * New upstream version 0.7.0
  * Update symbols file

 -- Norbert Preining <norbert@preining.info>  Tue, 23 Apr 2019 20:09:44 +0900

xxhash (0.6.5-3) unstable; urgency=medium

  * update VCS and email

 -- Norbert Preining <norbert@preining.info>  Sun, 03 Mar 2019 09:19:39 +0900
