=== debian/control ===
--- 
+++ 
@@ -1,12 +1,12 @@
 Source: xxhash
 Section: utils
 Priority: optional
-Maintainer: Norbert Preining <preining@debian.org>
+Maintainer: Norbert Preining <norbert@preining.info>
 Build-Depends: debhelper (>= 11), dpkg-dev (>= 1.16.2)
 Standards-Version: 4.2.1
 Homepage: https://cyan4973.github.io/xxHash
-Vcs-Git: https://salsa.debian.org/preining/xxhash.git
-Vcs-Browser: https://salsa.debian.org/preining/xxhash
+Vcs-Git: https://github.com/norbusan/debian-xxhash.git
+Vcs-Browser: https://github.com/norbusan/debian-xxhash
 
 Package: xxhash
 Architecture: any
