## xxhash 0.7.2

=== debian/changelog ===
xxhash (0.7.2-1) unstable; urgency=medium

  * New upstream version 0.7.2

 -- Norbert Preining <norbert@preining.info>  Sat, 12 Oct 2019 23:39:04 +0900

xxhash (0.7.1-1) unstable; urgency=medium

  * New upstream version 0.7.1
  * Update symbols file

 -- Norbert Preining <norbert@preining.info>  Tue, 03 Sep 2019 10:36:52 +0900
